<script lang="ts">
  import { OrkgAgent } from "$lib/controller/orkgAgent";
  import { notificationStore } from "$lib/stores/clientNotification.store";
  import { NotificationType } from "$lib/types/clientNotification.type";
  import { orkgApiVersion, orkgAuthState } from "$lib/stores/authTokens.store";

  let username: string;
  let password: string;

  async function submitForm() {
    const authToken = await OrkgAgent.getInstance().getAuthToken(
      username,
      password
    );
    if (authToken !== "") {
      $orkgAuthState[$orkgApiVersion].accessToken = authToken;
      notificationStore.set({
        type: NotificationType.success,
        title: "Success",
        message: "Successful authentication",
      });
      closeDialog();
    } else {
      // Show some error that the authentication failed
      notificationStore.set({
        type: NotificationType.error,
        title: "ORKG Error",
        message:
          "Authentication failed. Please check that the email address and password are correct",
      });
      console.error("Authentication Failed");
    }
  }

  export let closeDialog: () => void;
</script>

<div class="p-2">
  <form on:submit|preventDefault={submitForm}>
    <div class="mb-4">
      <label for="email" class="block mb-2 text-sm text-gray-800">
        Email address
      </label>
      <input
        type="email"
        name="email"
        id="email"
        class="focus:border-blue-500 appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none"
        placeholder="Email address"
        required
        bind:value={username}
      />
    </div>
    <div class="mb-4">
      <label for="password" class="block mb-2 text-sm text-gray-800">
        Password
      </label>
      <input
        type="password"
        name="password"
        id="password"
        class="focus:border-blue-500 appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none"
        placeholder="Password"
        required
        bind:value={password}
      />
    </div>
    <div class="block md:flex items-center justify-between">
      <button
        type="submit"
        class="align-middle bg-blue-500 hover:bg-blue-600 text-center px-4 py-2 text-white text-sm font-semibold rounded-lg inline-block shadow-lg"
      >
        LOGIN
      </button>
    </div>
  </form>
</div>
